<template>
  <q-page class="font row flex-center">
    <q-card class="q-pa-xl" border="true">
      <div class="row flex-center">
        <span class="text-h2">Thank you for signing up!</span>
      </div>
      <div class="column flex-center q-mt-lg">
        <span class="text-h3">Event will start in</span>
        <div class="column text-h4">
          <div class="row text-center">
            <div class="col">
              <div class="text-h2">{{ countdown.days }}</div>
              <span class="text-subtitle2">DAYS</span>
            </div>
            <div class="col text-h2">|</div>
            <div class="col">
              <div class="text-h2">{{ countdown.hours }}</div>
              <span class="text-subtitle2">HOURS</span>
            </div>
            <div class="col text-h2">|</div>
            <div class="col">
              <div class="text-h2">{{ countdown.minutes }}</div>

              <span class="text-subtitle2">MINUTES</span>
            </div>
          </div>
        </div>
      </div>
    </q-card>
  </q-page>
</template>

<script>
import { defineComponent, ref, onMounted } from 'vue'

export default defineComponent({
  name: 'RegistrationComplete',
  setup() {
    const event = new Date('March 15, 2022 5:00 PM')
    const countdown = ref({
      days: '',
      hours: '',
      minutes: ''
    })

    function initCountdown() {
      const daysInMs = 1000 * 60 * 60 * 24
      const hoursInMs = 1000 * 60 * 60
      const minutesInMs = 1000 * 60

      const msBetweenNowAndEvent = event.getTime() - new Date().getTime()
      const computedDays = Math.floor(msBetweenNowAndEvent / daysInMs)
      // Need to get remainder here from computed days for hours and minutes
      const computedHours = Math.floor(
        (msBetweenNowAndEvent % daysInMs) / hoursInMs
      )
      const computedMinutes = Math.floor(
        (msBetweenNowAndEvent % hoursInMs) / minutesInMs
      )

      countdown.value.days = computedDays
      countdown.value.hours = computedHours
      countdown.value.minutes = computedMinutes
    }

    onMounted(() => {
      initCountdown()
      setInterval(() => {
        initCountdown()
      }, 1000)
    })

    return {
      countdown
    }
  }
})
</script>

<style scoped>
.font {
  color: green;
}
</style>
